import QtQuick 2.5
import com.zuragon.ViCANdo 1.0
import QtQuick.Controls 1.4

Rectangle {
    id: rectangle1
    width: 600
    height: 400
    color: "#E0E0E0"


    SourceEventListener {
        source: project.findObject("udp0")

        onDataReceived: {
	     project.log("udp0 receives data: " + data.data)
        }
    }


    SourceEventListener {
        source: project.findObject("udp1")

        onDataReceived: {
	    project.log("udp1 receives data: " + data.data)

            /* Forward to CAN0 */
            var can0 = project.findObject("can0")

            var id = data.data[0]
            var can_data = data.data.slice(1)
            can0.sendStandard(id,can_data)
            project.log("From udp1 to can0. Data: " + can_data + ". id: " + id)
        }
    }

    SourceEventListener {
        source: project.findObject("can0")
        
        onDataReceived: {
	    project.log("can0 receives data: " + data.data + ". id: " + data.id)
        }
    }

    SourceEventListener {
        source: project.findObject("can1")

        onDataReceived: {
	    project.log("can1 receives data: " + data.data + ". id: " + data.id);

            project.log("From can1 to RS232 com0. Data: " + data.data);
            var com0 = project.findObject("com0")
            com0.send(data.data)

	    var text = "Hello from can1 to com0"
            com0.sendText(text)
            project.log("From can1 to RS232 com0. Text: " + text);
        }
    }

    SourceEventListener {
        source: project.findObject("com0")
        
        onDataReceived: {
	    project.log("RS232 com0 receives data: " + data.data)
        }
    }

    Button {
        id: send_udp0
        x: 29
        y: 188
        width: 106
        height: 25
        text: qsTr("Send to peer")

        onClicked: {
            var udp0 = project.findObject("udp0")
            var d = [1,2,3,4,5,6,7,8,9]
            udp0.send(d)
	    project.log("From udp0 to peer. Data " + d)
        }
    }

    Button {
        id: send_udp1
        x: 180
        y: 188
        width: 98
        height: 25
        text: qsTr("Send to")

        onClicked: {
            var udp1 = project.findObject("udp1")
            var d = [11,22,33,44,55,66,77,88,99]
            udp1.send(d, host_address.text, host_port.text)
	    project.log("From udp1 to " + host_address.text + ", port " + host_port.text + ". " + "Data " + d)
        }
    }

    Label {
        id: label_title
        x: 31
        y: 30
        width: 600
        height: 17
	wrapMode: Text.Wrap
        text: qsTr("UDP2CAN QML example: Click Send to peer button to send from UDP Client(udp0) to UDP server(udp1).  Configure and click Send to button, to send from UDP server(udp1) to UDP client and CAN source(can0)  and CAN source(can1).")
    }
    Label {
        id: label
        x: 31
        y: 158
        width: 101
        height: 17
        text: qsTr("Client - udp0")
    }

    Label {
        id: label1
        x: 180
        y: 158
        text: qsTr("Server - udp1")
    }

    TextField {
        id: host_address
        x: 280
        y: 190
        width: 115
        height: 23
        placeholderText: qsTr("Host address")
    }

    TextField {
        id: host_port
        x: 400
        y: 190
        width: 65
        height: 23
        placeholderText: qsTr("Host port")
    }


}
